' Lemmings Functions Core
' Footer File
' by Namida Verasche
' see lf_core_head.bas for info

'$INCLUDE:'lf_dat_foot.bas'
'$INCLUDE:'lf_gfx_foot.bas'
'$INCLUDE:'lf_grd_foot.bas'

FUNCTION lfc_new_image (width, height)
k = lfc_freeimage
IF k = -1 THEN
  lfc_new_image = -1
  EXIT FUNCTION
END IF
lfc_images(k, 0) = width
lfc_images(k, 1) = height
for y = 0 to height-1
  for x = 0 to width-1
    lfc_imagedata(k, x, y, 0) = 255
	lfc_imagedata(k, x, y, 1) = 0
	lfc_imagedata(k, x, y, 2) = 255
  next
next
lfc_new_image = k
END FUNCTION

FUNCTION lfc_load_image (filename$)
k = lfc_freeimage
IF k = -1 THEN
    lfc_load_image = -1
    EXIT FUNCTION
END IF

th = _LOADIMAGE(filename$, 32)

if th = -1 then
  k = lfc_load_image_old(filename$)
else
_SOURCE th

lfc_images(k, 0) = _width(th)
lfc_images(k, 1) = _height(th)

FOR x = 0 TO _width(th) - 1
    FOR y = 0 TO _height(th) - 1
        c& = POINT(x, y)
        lfc_imagedata(k, x, y, 0) = _RED32(c&)
        lfc_imagedata(k, x, y, 1) = _GREEN32(c&)
        lfc_imagedata(k, x, y, 2) = _BLUE32(c&)
    NEXT
NEXT

_FREEIMAGE th
end if
lfc_load_image = k
END FUNCTION

FUNCTION lfc_load_image_old (filename$)
k = lfc_freeimage
IF k = -1 THEN
  lfc_load_image_old = -1
  EXIT FUNCTION
END IF
v = lfc_open_file (filename$)
lfc_small_endian v
posit = lfc_get_short(v, 10)
tyid = lfc_get_short(v, 14)
if tyid = 12 then
  width = lfc_get_short(v, 18)
  height = lfc_get_short(v, 20)
  flipbyte = 0
else
  width = lfc_get_short(v, 18)
  height = lfc_get_short(v, 22)
  flipbyte = lfc_get_byte(v, 25)
end if
if flipbyte <> 0 then
  height = height - 65536
  ustep = 1
end if
lfc_images(k, 0) = width
lfc_images(k, 1) = height
ustep = -1
for y = (height-1) to 0 step ustep
  for x = 0 to width-1
    for col = 2 to 0 step -1
	  lfc_imagedata(k, x, y, col) = lfc_get_byte(v, posit)
	  posit = posit + 1
	next
  next
next
lfc_close_file v
lfc_load_image_old = k
END FUNCTION

SUB lfc_save_image (inum, filename$)
  k = lfc_new_file (filename$)
  lfc_small_endian k
  lfc_put_short k, 0, 19778
  lfc_put_short k, 2, 0
  lfc_put_short k, 4, 0
  lfc_put_short k, 6, 0
  lfc_put_short k, 8, 0
  lfc_put_short k, 10, 54
  lfc_put_short k, 12, 0
  lfc_put_short k, 14, 40
  lfc_put_short k, 16, 0
  lfc_put_short k, 18, lfc_images(inum, 0)
  lfc_put_short k, 20, 0
  lfc_put_short k, 22, lfc_images(inum, 1)
  lfc_put_short k, 24, 0
  lfc_put_short k, 26, 1
  lfc_put_short k, 28, 24
  for x = 0 to 19
    lfc_put_byte k, 30+x, 0
  next
  posit = 54
  cbyte = 0
  for y = lfc_images(inum,1) - 1 to 0 step -1
    for x = 0 to lfc_images(inum,0) - 1
	  'if lfc_get_pixel_alpha(inum, x, y) = 0 then
	  '  lfc_put_short k, posit+cbyte, 255
	  '  lfc_put_byte k, posit+cbyte, 255
	  'else
	  lfc_put_byte k, posit+cbyte, lfc_get_pixel_blue(inum, x, y)
	  lfc_put_byte k, posit+cbyte+1, lfc_get_pixel_green(inum, x, y)
	  lfc_put_byte k, posit+cbyte+2, lfc_get_pixel_red(inum, x, y)
	  'end if
	  cbyte = cbyte + 3
	next
	while cbyte mod 4 <> 0
	  lfc_put_byte k, posit+cbyte, 0
	  cbyte = cbyte + 1
	wend
  next
  lfc_save_file k
  lfc_close_file k
end sub

SUB lfc_close_image (inum)
lfc_images(inum, 0) = 0
lfc_images(inum, 1) = 0
END SUB

SUB lfc_clone_image (src, dst, x, y)
srcwid = lfc_images(src, 0)
srchgt = lfc_images(src, 1)
for y1 = y to (y+srchgt-1)
  for x1 = x to (x+srcwid-1)
    for p = 0 to 2
      lfc_imagedata(dest, x1, y1, p) = lfc_imagedata(src, x1-x, y1-y, p)
	  next
  next
next
END SUB

function lfc_sect_image (src, x, y, width, height)
t = lfc_new_image(width, height)
for y1 = y to (y+height-1)
  for x1 = x to (x+width-1)
    for p = 0 to 2
	  lfc_imagedata(t, x1-x, y1-y, p) = lfc_imagedata(src, x1, y1, p)
	next
  next
next
lfc_sect_image = t
end function

SUB lfc_set_pixel (inum, x, y, r, g, b)
lfc_imagedata(inum, x, y, 0) = r
lfc_imagedata(inum, x, y, 1) = g
lfc_imagedata(inum, x, y, 2) = b
END SUB

FUNCTION lfc_get_pixel_red (inum, x, y)
lfc_get_pixel_red = lfc_imagedata(inum, x, y, 0)
END FUNCTION

FUNCTION lfc_get_pixel_green (inum, x, y)
lfc_get_pixel_green = lfc_imagedata(inum, x, y, 1)
END FUNCTION

FUNCTION lfc_get_pixel_blue (inum, x, y)
lfc_get_pixel_blue = lfc_imagedata(inum, x, y, 2)
END FUNCTION

FUNCTION lfc_get_pixel_alpha (inum, x, y)
lfc_get_pixel_alpha = 0
if lfc_get_pixel_red(inum, x, y) <> 255 then lfc_get_pixel_alpha = 1
if lfc_get_pixel_green(inum, x, y) <> 0 then lfc_get_pixel_alpha = 1
if lfc_get_pixel_blue(inum, x, y) <> 255 then lfc_get_pixel_alpha = 1
END FUNCTION

FUNCTION lfc_freeimage
lfc_freeimage = -1
FOR tk = 0 TO lfc_max_images
  IF lfc_images(tk, 0) = 0 THEN EXIT FOR
NEXT
lfc_freeimage = tk
END FUNCTION

function lfc_freeini
lfc_freeini = -1
for k = 0 to lfc_max_ini
  if lfc_ini(k) = 0 then
    lfc_freeini = k
	exit for
  end if
next
end function

function lfc_new_ini
k = lfc_freeini
if k = -1 then
  lfc_new_ini = -1
  exit function
end if
lfc_ini(k) = 1
for x = 0 to lfc_max_ini_entries
  lfc_inidata(k, x, 0) = ""
  lfc_inidata(k, x, 1) = ""
next
lfc_new_ini = k
end function

function lfc_load_ini (filename$)
k = lfc_new_ini
if k = -1 then
  lfc_load_ini = -1
  exit function
end if
n = lfc_open_file(filename$)
ce = 0
a$ = ""
gk = 0
for cbyte = 0 to lfc_files(n).size-1
  b$ = lfc_get_string(n, cbyte, 1)
  if b$ = "=" then
    if gk = 0 then lfc_inidata(k, ce, 0) = a$
	a$ = ""
	gk = 1
  else
    if asc(b$) = 13 or asc(b$) = 10 then
	  if gk = 1 then
	    lfc_inidata(k, ce, 1) = a$
		ce = ce + 1
	  end if
	  a$ = ""
	  gk = 0
	  b$ = lfc_get_string(n, cbyte+1, 1)
	  if asc(b$) = 13 or asc(b$) = 10 then cbyte = cbyte + 1
	else
	  if b$ <> " " then a$ = a$ + b$
	end if
  end if
next
if gk = 1 then lfc_inidata(k, ce, 1) = a$
lfc_load_ini = k
end function

sub lfc_save_ini (inum, filename$)
k = lfc_new_file(filename$)
newline = 3338
posit = 0
for x = 0 to lfc_max_ini_entries
  if lfc_inidata(inum, x, 0) <> "" then
    a$ = lfc_inidata(inum, x, 0) + "=" + lfc_inidata(inum, x, 1)
    lfc_put_string k, posit, a$
	lfc_put_short k, posit+len(a$), newline
	posit = posit + len(a$) + 2
  end if
next
lfc_save_file k
lfc_close_file k
end sub

sub lfc_close_ini (inum)
  lfc_ini(inum) = 0
end sub

function lfc_locate_key (inum, lkey$)
lfc_locate_key = -1
  for x = 0 to lfc_max_ini_entries
    if lcase$(lfc_inidata(inum, x, 0)) = lcase$(lkey$) then
	  lfc_locate_key = x
	  exit for
	end if
  next
end function

function lfc_free_key (inum)
lfc_free_key = lfc_locate_key(inum, "")
end function

sub lfc_delete_key(inum, lkey$)
x = lfc_locate_key(inum, lkey$)
if x <> -1 then
  lfc_inidata(inum, x, 0) = ""
  lfc_inidata(inum, x, 1) = ""
end if
end sub

function lfc_get_ini_value$(inum, lkey$)
t = lfc_locate_key(inum, lkey$)
if t = -1 then
  lfc_get_ini_value$ = ""
else
  lfc_get_ini_value$ = lfc_inidata(inum, t, 1)
end if
end function

sub lfc_set_ini_value(inum, lkey$, pval$)
t = lfc_locate_key(inum, lkey$)
if t = -1 then t = lfc_free_key(inum)
lfc_inidata(inum, t, 0) = lkey$
lfc_inidata(inum, t, 1) = pval$
end sub

FUNCTION lfc_freefile
lfc_freefile = -1
FOR k = 0 TO lfc_maxfiles
  IF lfc_files(k).in_use = 0 THEN
    lfc_freefile = k
    EXIT FOR
  END IF
NEXT
END FUNCTION

FUNCTION lfc_new_file (filename$)
k = lfc_freefile
IF k = -1 THEN
  lfc_new_file = -1
  EXIT FUNCTION
END IF
lfc_files(k).name = filename$
lfc_files(k).in_use = 1
lfc_files(k).endian = 0
lfc_files(k).size = 0
lfc_new_file = k
END FUNCTION

FUNCTION lfc_open_file (filename$)
k = FREEFILE
OPEN filename$ FOR BINARY AS k
x = lfc_freefile
IF x = -1 THEN
  lfc_open_file = -1
  EXIT FUNCTION
END IF
lfc_files(x).name = filename$
lfc_files(x).in_use = 1
lfc_files(x).endian = 0
lfc_files(x).size = LOF(k)
lfc_load_file x, k
CLOSE k
lfc_open_file = x
END FUNCTION

SUB lfc_load_file (fnum, k)
FOR x = 1 TO lfc_files(fnum).size
  GET k, x, lfc_filedata(fnum, x - 1)
NEXT
END SUB

FUNCTION lfc_find_file (filename$)
lfc_find_file = -1
FOR tfile = 0 TO lfc_maxfiles
  IF lfc_files(tfile).name = filename$ THEN
    lfc_find_file = tfile
    EXIT FOR
  END IF
NEXT
END FUNCTION

SUB lfc_save_file (filenum)
IF lfc_file_open(filenum) = 0 THEN EXIT SUB
k = FREEFILE
n$ = lfc_files(filenum).name
WHILE RIGHT$(n$, 1) = " "
  n$ = LEFT$(n$, LEN(n$) - 1)
WEND
IF _FILEEXISTS(n$) THEN KILL n$
OPEN n$ FOR BINARY AS k
DIM v AS _UNSIGNED _BYTE
FOR x = 1 TO lfc_files(filenum).size
  PUT k, x, lfc_filedata(filenum, x - 1)
NEXT
CLOSE k
END SUB

SUB lfc_rename_file (filenum, filename$)
IF lfc_file_open(filenum) = 0 THEN EXIT SUB
lfc_files(filenum).name = filename$
END SUB

SUB lfc_close_file (filenum)
lfc_files(filenum).name = ""
lfc_files(filenum).in_use = 0
lfc_files(filenum).endian = 0
END SUB

FUNCTION lfc_file_open (filenum)
lfc_file_open = lfc_files(filenum).in_use
END FUNCTION

SUB lfc_small_endian (filenum)
lfc_files(filenum).endian = 1
END SUB

SUB lfc_big_endian (filenum)
lfc_files(filenum).endian = 0
END SUB

SUB lfc_adjust_position (posit)
posit = posit
END SUB

FUNCTION lfc_get_byte (filenum, posit)
lfc_adjust_position posit
IF lfc_file_open(filenum) = 0 THEN
  lfc_get_byte = 0
  EXIT FUNCTION
END IF
lfc_get_byte = lfc_filedata(filenum, posit)
END FUNCTION

FUNCTION lfc_get_short (filenum, posit)
lfc_adjust_position posit
IF lfc_file_open(filenum) = 0 THEN
  lfc_get_short = 0
  EXIT FUNCTION
END IF
IF lfc_files(filenum).endian = 0 THEN
  lfc_get_short = (lfc_filedata(filenum, posit) * 256) + lfc_filedata(filenum, posit + 1)
ELSE
  lfc_get_short = (lfc_filedata(filenum, posit + 1) * 256) + lfc_filedata(filenum, posit)
END IF
END FUNCTION

FUNCTION lfc_get_string$ (filenum, posit, slen)
lfc_adjust_position posit
IF lfc_file_open(filenum) = 0 THEN
  lfc_get_string$ = ""
  EXIT FUNCTION
END IF
a$ = ""
FOR x = 0 TO slen - 1
  a$ = a$ + CHR$(lfc_filedata(filenum, posit+x))
NEXT
lfc_get_string$ = a$
END FUNCTION

SUB lfc_get_array (filenum, posit, arr() AS _UNSIGNED _BYTE)
lfc_adjust_position posit
arsize = lfc_array_size(arr())
IF lfc_file_open(filenum) = 0 THEN
  arr(0) = 99
  IF arsize > 1 THEN arr(1) = 14
  EXIT SUB
END IF
FOR x = 0 TO arsize - 1
  arr(x) = lfc_filedata(filenum, posit + x)
NEXT
END SUB
  

SUB lfc_patch_length (filenum, tlen)
IF lfc_file_open(filenum) = 0 THEN EXIT SUB
FOR x = lfc_files(filenum).size TO tlen
  lfc_filedata(filenum, x) = 0
NEXT
IF lfc_files(filenum).size <= tlen THEN lfc_files(filenum).size = tlen + 1
END SUB

SUB lfc_put_byte (filenum, posit, value)
lfc_adjust_position posit
IF lfc_file_open(filenum) = 0 THEN EXIT SUB
lfc_patch_length filenum, posit
lfc_filedata(filenum, posit) = value
END SUB

SUB lfc_put_short (filenum, posit, value)
lfc_adjust_position posit
IF lfc_file_open(filenum) = 0 THEN EXIT SUB
lfc_patch_length filenum, posit + 1
IF lfc_files(filenum).endian = 0 THEN
  a = INT(value / 256)
  b = value MOD 256
ELSE
  a = value MOD 256
  b = INT(value / 256)
END IF
lfc_filedata(filenum, posit) = a
lfc_filedata(filenum, posit + 1) = b
END SUB

SUB lfc_put_string (filenum, posit, value$)
lfc_adjust_position posit
IF lfc_file_open(filenum) = 0 THEN EXIT SUB
lfc_patch_length filenum, posit + LEN(value$) - 1
FOR dc = 1 TO LEN(value$)
  lfc_filedata(filenum, posit + dc - 1) = ASC(value$, dc)
NEXT
END SUB

SUB lfc_put_array (filenum, posit, arr() AS _UNSIGNED _BYTE)
lfc_adjust_position posit
IF lfc_file_open(filenum) = 0 THEN EXIT SUB
arsize = lfc_array_size(arr())
lfc_patch_length filenum, posit + arsize - 1
FOR tval = 0 TO arsize - 1
  lfc_filedata(filenum, posit + tval) = arr(tval)
NEXT
END SUB

SUB lfc_shift_bytes (filenum, posit, shiftto)
shiftdist = shiftto - posit
IF shiftdist = 0 THEN EXIT SUB
IF lfc_file_open(filenum) = 0 THEN EXIT SUB
csize = lfc_files(filenum).size - posit - 1
DIM tbyte(csize) AS _UNSIGNED _BYTE
lfc_get_array filenum, posit, tbyte()
FOR x = 0 TO shiftdist - 1
  lfc_put_byte filenum, posit + x, 0
NEXT
lfc_put_array filenum, posit + shiftdist, tbyte()
IF shiftdist < 0 THEN lfc_files(filenum).size = lfc_files(filenum).size + shiftdist
END SUB
  
FUNCTION lfc_str$ (invl)
lfc_str$ = MID$(STR$(invl), 2)
END FUNCTION

FUNCTION lfc_pad_str$ (invl, tlen)
o$ = lfc_str$(invl)
while len(o$) < tlen
  o$ = "0" + o$
wend
lfc_pad_str$ = o$
END FUNCTION

function lfc_read
READ a$
lfc_read = VAL(a$)
END SUB

FUNCTION lfc_array_size (arry() AS _UNSIGNED _BYTE)
x = UBOUND(arry) + 1
lfc_array_size = x
END FUNCTION