' Lemmings Functions - Ground Tool
' Footer File
' by Namida Verasche
' see lf_grd_head.bas for info

SUB lfr_put_object (fnum, entry, indat AS lfr_object_data)
if entry >= 16 then
  posit = 1056 + ((entry - 16) * 28)
else
  posit = entry * 28
end if
lfc_put_short fnum, posit, indat.animation_flags
lfc_put_byte fnum, posit + 2, indat.start_animation_frame_index
lfc_put_byte fnum, posit + 3, indat.end_animation_frame_index
lfc_put_byte fnum, posit + 4, indat.width
lfc_put_byte fnum, posit + 5, indat.height
lfc_put_short fnum, posit + 6, indat.animation_frame_data_size
lfc_put_short fnum, posit + 8, indat.mask_offset_from_image
lfc_put_short fnum, posit + 10, indat.unknown1
lfc_put_short fnum, posit + 12, indat.unknown2
lfc_put_byte fnum, posit + 14, indat.trigger_left
lfc_put_byte fnum, posit + 15, indat.trigger_px
lfc_put_byte fnum, posit + 16, indat.trigger_top
lfc_put_byte fnum, posit + 17, indat.trigger_py
lfc_put_byte fnum, posit + 18, indat.trigger_width
lfc_put_byte fnum, posit + 19, indat.trigger_height
lfc_put_byte fnum, posit + 20, indat.trigger_effect_id
lfc_put_short fnum, posit + 21, indat.animation_frames_base_loc
lfc_put_short fnum, posit + 23, indat.preview_image_index
lfc_put_short fnum, posit + 25, indat.unknown3
lfc_put_byte fnum, posit + 27, indat.trap_sound_effect_id
END SUB

SUB lfr_get_object (fnum, entry, indat as lfr_object_data)
if entry >= 16 then
  posit = 1056 + ((entry - 16) * 28)
else
  posit = entry * 28
end if
indat.animation_flags = lfc_get_short(fnum, posit)
indat.start_animation_frame_index = lfc_get_byte(fnum, posit + 2)
indat.end_animation_frame_index = lfc_get_byte(fnum, posit + 3)
indat.width = lfc_get_byte(fnum, posit + 4)
indat.height = lfc_get_byte(fnum, posit + 5)
indat.animation_frame_data_size = lfc_get_short(fnum, posit + 6)
indat.mask_offset_from_image = lfc_get_short(fnum, posit + 8)
indat.unknown1 = lfc_get_short(fnum, posit + 10)
indat.unknown2 = lfc_get_short(fnum, posit + 12)
indat.trigger_left = lfc_get_byte(fnum, posit + 14)
indat.trigger_px = lfc_get_byte(fnum, posit+15)
indat.trigger_top = lfc_get_byte(fnum, posit + 16)
indat.trigger_py = lfc_get_byte(fnum, posit + 17)
indat.trigger_width = lfc_get_byte(fnum, posit + 18)
indat.trigger_height = lfc_get_byte(fnum, posit + 19)
indat.trigger_effect_id = lfc_get_byte(fnum, posit + 20)
indat.animation_frames_base_loc = lfc_get_short(fnum, posit + 21)
indat.preview_image_index = lfc_get_short(fnum, posit + 23)
indat.unknown3 = lfc_get_short(fnum, posit + 25)
indat.trap_sound_effect_id = lfc_get_byte(fnum, posit + 27)
end sub

SUB lfr_put_terrain (fnum, entry, indat as lfr_terrain_data)
if entry >= 64 then
  posit = 1056 + 448 + (8 * (entry-64))
else
  posit = 448 + (8 * entry)
end if
lfc_put_byte fnum, posit, indat.width
lfc_put_byte fnum, posit+1, indat.height
lfc_put_short fnum, posit+2, indat.image_loc
lfc_put_short fnum, posit+4, indat.mask_loc
lfc_put_short fnum, posit+6, indat.unknown1
end sub

sub lfr_get_terrain (fnum, entry, outdat as lfr_terrain_data)
if entry >= 64 then
  posit = 1056 + 448 + (8 * (entry-64))
else
  posit = 448 + (8 * entry)
end if
outdat.width = lfc_get_byte(fnum, posit)
outdat.height = lfc_get_byte(fnum, posit+1)
outdat.image_loc = lfc_get_short(fnum, posit+2)
outdat.mask_loc = lfc_get_short(fnum, posit+4)
outdat.unknown1 = lfc_get_short(fnum, posit+6)
end sub

sub lfr_load_palette (fnum, psize)
dim arry(95) as _unsigned _byte
lfc_get_array fnum, 960, arry()
if psize = 16 then
  lfg_input_palette_array arry()
else
  lfg_input_palette_array_32 arry()
end if
end sub

sub lfr_save_palette (fnum)
dim arry(0) as _unsigned _byte
lfg_output_palette_array arry()
lfc_put_array fnum, 960, arry()
end sub

sub lfr_set_obj_values_from_image (inum, iodat as lfr_object_data)
  iodat.width = lfc_images(inum, 0)
  iodat.height = lfc_images(inum, 1) / iodat.end_animation_frame_index
end sub

sub lfr_set_obj_deriv_values (iodat as lfr_object_data, palbit)
  iodat.animation_frame_data_size = iodat.width * iodat.height * (palbit + 1) / 8
  iodat.mask_offset_from_image = iodat.width * iodat.height * palbit / 8
  'iodat.unknown1 = iodat.mask_offset_from_image
  'iodat.unknown2 = iodat.mask_offset_from_image / 2
  if iodat.preview_image_index = 0 then iodat.preview_image_index = iodat.animation_frames_base_loc
end sub

sub lfr_set_preview_image (tframe, iodat as lfr_object_data)
  iodat.preview_image_index = iodat.animation_frames_base_loc + (iodat.animation_frame_data_size * tframe)
end sub

function lfr_get_preview_image (iodat as lfr_object_data)
  lfr_get_preview_image = int((iodat.preview_image_index - iodat.animation_frames_base_loc) / iodat.animation_frame_data_size)
end function

sub lfr_set_window_values (iodat as lfr_object_data)
  iodat.animation_flags = 3
  iodat.start_animation_frame_index = 1
  iodat.preview_image_index = iodat.animation_frames_base_loc + iodat.animation_frame_data_size
end sub

sub lfr_set_defaults (iodat as lfr_object_data)
  iodat.animation_flags = 0
  iodat.start_animation_frame_index = 0
  iodat.end_animation_frame_index = 0
  iodat.width = 0
  iodat.height = 0
  iodat.animation_frame_data_size = 0
  iodat.mask_offset_from_image = 0
  iodat.unknown1 = 0
  iodat.unknown2 = 0
  iodat.trigger_left = 0
  iodat.trigger_top = 0
  iodat.trigger_px = 0
  iodat.trigger_py = 0
  iodat.trigger_width = 1
  iodat.trigger_height = 1
  iodat.trigger_effect_id = 0
  iodat.animation_frames_base_loc = 0
  iodat.preview_image_index = 0
  iodat.unknown3 = 0
  iodat.trap_sound_effect_id = 0
end sub