decompilestyle:

PRINT "Enter style name to decompile."
Print "For numbered styles (VGAGRx.DAT / GROUNDxO.DAT) enter just the"
Print "number. Otherwise, enter just the name. Leave blank to enter"
Print "custom filenames for both files."
INPUT "> ", decnum$

if decnum$ = "" then
  Print "Enter GROUND filename: ";
  Input "", grfile$
  Print "Enter VGAGR filename: ";
  Input "", vgagrfile$
  decnum = -1
else
  if lfc_str$(val(decnum$)) = decnum$ then
    decnum = val(decnum$)
    grfile$ = "GROUND" + lfc_str$(decnum) + "O.DAT"
    vgagrfile$ = "VGAGR" + lfc_str$(decnum) + ".DAT"
  else
    decnum = -2
    grfile$ = "g_" + decnum$ + ".dat"
	vgagrfile$ = "v_" + decnum$ + ".dat"
  end if
end if

PRINT "Enter output prefix: ";
input "", outprefix$

if outprefix$ <> "" then
  ininame$ = outprefix$ + ".ini"
  outprefix$ = outprefix$ + "_"
else
  ininame$ = "style.ini"
end if

PRINT "  Loading style files to memory..."
if (_fileexists(grfile$) = 0) or (_fileexists(vgagrfile$) = 0) then
  Print "Error: File(s) not found!"
  end
end if

grfile = lfc_open_file(grfile$)
lfc_small_endian grfile

vgtemp = lfc_open_file(vgagrfile$)
vg0 = lfd_extract_section(vgtemp, 0)
vg1 = lfd_extract_section(vgtemp, 1)
lfc_close_file vgtemp

DIM obj0info as lfr_object_data
lfr_get_object grfile, 0, obj0info

autosteel = 0
extpal = 0
perftrig = 0
xmaspal = 0
extloc = 0

if (obj0info.animation_flags and 256) <> 0 then extpal = 1
if (obj0info.animation_flags and 512) <> 0 then perftrig = 1
if (obj0info.animation_flags and 1024) <> 0 then autosteel = 1
if (obj0info.animation_flags and 2048) <> 0 then xmaspal = 1
if (obj0info.animation_flags and 4096) <> 0 then
  Print "Error: This style cannot be decompiled."
  end
end if
if (obj0info.animation_flags and 8192) <> 0 then extloc = 1
if (obj0info.animation_flags and 16384) <> 0 then rgbpal = 1
if (obj0info.animation_flags and 32768) <> 0 then multiwin = 1

Print "Generating palette BMP..."

outini = lfc_new_ini

if decnum <> -1 then
  if decnum <> -2 then
    lfc_set_ini_value outini, "style_number", lfc_str$(decnum)
  else
    lfc_set_ini_value outini, "style_name", decnum$
  end if
end if

lfc_set_ini_value outini, "palette_info", "BMP"

if rgbpal = 1 then
  lfc_set_ini_value outini, "rgb_images", "1"
  palbit = 19
else
  palbit = 4 + extpal
end if

if multiwin = 1 then
  lfc_set_ini_value outini, "multi_windows", "1"
end if

palsize = 16 * (extpal + 1)
pi = lfc_new_image(palsize, 1)

lfr_load_palette grfile, palsize

nnt = 0

if palsize = 16 then
  if lfg_active_palette(1).vga_red = lfg_default_low8(5).vga_red and lfg_active_palette(1).vga_green = lfg_default_low8(5).vga_green and lfg_active_palette(1).vga_blue = lfg_default_low8(5).vga_blue then
    xmaspal = 1
  end if
end if

lfg_reset_low8

if xmaspal = 1 then
  lfg_reset_low8_xmas
end if



if xmaspal = 1 then lfc_set_ini_value outini, "xmas_palette", "1"  

for x = 0 to palsize-1
  lfc_set_pixel pi, x, 0, lfg_active_palette(x).vga_red * 4, lfg_active_palette(x).vga_green * 4, lfg_active_palette(x).vga_blue * 4
  if lfg_active_palette(x).vga_red = int(transcolor(0) / 4) and lfg_active_palette(x).vga_green = int(transcolor(1) / 4) and lfg_active_palette(x).vga_blue = int(transcolor(2) / 4) then nnt = 1
next

lfc_save_image pi, outprefix$ + "palette.bmp"
lfc_close_image pi

if palbit = 19 then nnt = 0

if nnt = 1 then
  Print "Error: Style uses magenta as a palette color."
  Print "  Attempting to autoselect a new transparent color."
  for x = 0 to 2
    transcolor(0) = 0
	transcolor(1) = 0
	transcolor(2) = 0
	transcolor(x) = 255
	nnt = 0
	for x = 0 to palsize - 1
	  if lfg_active_palette(x).vga_red = int(transcolor(0) / 4) and lfg_active_palette(x).vga_green = int(transcolor(1) / 4) and lfg_active_palette(x).vga_blue = int(transcolor(2) / 4) then nnt = 1
	next
	if nnt = 0 then exit for
  next
end if

if nnt = 1 then
  for x = 0 to 2
    transcolor(0) = 255
	transcolor(1) = 255
	transcolor(2) = 255
	transcolor(x) = 0
	nnt = 0
	for x = 0 to palsize - 1
	  if lfg_active_palette(x).vga_red = int(transcolor(0) / 4) and lfg_active_palette(x).vga_green = int(transcolor(1) / 4) and lfg_active_palette(x).vga_blue = int(transcolor(2) / 4) then nnt = 1
	next
	if nnt = 0 then exit for
  next
end if

if nnt = 1 then
  print "Error: All autoselect transparent colors are used by the style's palette."
  Print "  Please manually enter RGB values for a transparent color."
  Print "  (Enter as 24-bit values, not 18-bit)"
  Input "    Red: ", transcolor(0)
  Input "  Green: ", transcolor(1)
  Input "   Blue: ", transcolor(2) 
end if
bd = palbit


Print "Decoding terrain..."
dim getterdat as lfr_terrain_data
for x = 0 to 127
  lfr_get_terrain grfile, x, getterdat
  if getterdat.width = 0 then
    Print "  All terrain pieces decoded."
	exit for
  end if
  Print "  Decoding terrain "; lfc_str$(x); "..."
	texi = getterdat.image_loc
	if extloc = 1 then texi = texi + ((int(getterdat.unknown1 / 2) mod 128) * 65536)
	texmi = getterdat.mask_loc
	if extloc = 1 then texmi = texmi + (int(getterdat.unknown1 / 256) * 65536)
  ti = lfg_extract_image_mask(getterdat.width, getterdat.height, vg0, texi, texmi, bd)
  k$ = lfc_str$(x)
  if len(k$) = 1 then k$ = "0" + k$
  lfc_save_image ti, outprefix$ + "t" + k$ + ".bmp"
  lfc_close_image ti
  if ((getterdat.unknown1 and 1) <> 0) and (autosteel = 1) then lfc_set_ini_value outini, "terrain_" + lfc_str$(x) + "_steel", "1"
next

Print "Decoding objects..."
dim getterdat2 as lfr_object_data
for x = 0 to 31
  lfr_get_object grfile, x, getterdat2
  if getterdat2.width = 0 then
    Print "  All objects decoded."
	exit for
  end if
  Print "  Decoding object "; lfc_str$(x); "..." 
  
  opr$ = "object_" + lfc_str$(x) + "_"
  
  lfc_set_ini_value outini, opr$ + "frames", lfc_str$(getterdat2.end_animation_frame_index)
	if x <> 1 then
		if getterdat2.start_animation_frame_index <> 0 then lfc_set_ini_value outini, opr$ + "start_frame", lfc_str$(getterdat2.start_animation_frame_index)
		if getterdat2.trigger_effect_id <> 0 then
			lfc_set_ini_value outini, opr$ + "trigger_type", lfc_str$(getterdat2.trigger_effect_id)
		uk3 = 0
		if perftrig = 1 then uk3 = getterdat2.unknown3 mod 256
		tl = (getterdat2.trigger_left * 4) - (int(uk3 / 64) mod 4)
		tt = ((getterdat2.trigger_top - 1) * 4) - (int(uk3 / 16) mod 4)
		tw = (getterdat2.trigger_width * 4) - (int(uk3 / 4) mod 4)
		th = (getterdat2.trigger_height * 4) - (uk3 mod 4)
		lfc_set_ini_value outini, opr$ + "trigger_left", lfc_str$(tl)
		lfc_set_ini_value outini, opr$ + "trigger_top", lfc_str$(tt)
		lfc_set_ini_value outini, opr$ + "trigger_width", lfc_str$(tw)
		lfc_set_ini_value outini, opr$ + "trigger_height", lfc_str$(th)
		if getterdat2.trap_sound_effect_id <> 0 then lfc_set_ini_value outini, opr$ + "trigger_sound", lfc_str$(getterdat2.trap_sound_effect_id)
		end if
		if (getterdat2.animation_flags and 3) = 1 then lfc_set_ini_value outini, opr$ + "trigger_anim", "1"
		if (int(getterdat2.unknown3 / 256) <> 0) and (perftrig = 1) then lfc_set_ini_value outini, opr$ + "key_frame", lfc_str$(int(getterdat2.unknown3 / 256))

		a = lfr_get_preview_image(getterdat2)
		if a <> 0 then lfc_set_ini_value outini, opr$ + "preview_frame", lfc_str$(a)
	end if
	
	if (x = 1 and multiwin = 0) or (getterdat2.trigger_effect_id = 23) then
	  uk3 = 0
	  if perftrig = 1 then uk3 = getterdat2.unknown3 mod 256
	  tl = (getterdat2.trigger_left * 4) - (int(uk3 / 64) mod 4)
	  tt = ((getterdat2.trigger_top - 1) * 4) - (int(uk3 / 16) mod 4)
	  if (tl = 0) and ((tt = 0) or (tt = -4)) then
	    tl = 24
		tt = 13
	  end if
	  lfc_set_ini_value outini, opr$ + "trigger_left", lfc_str$(tl)
	  lfc_set_ini_value outini, opr$ + "trigger_top", lfc_str$(tt)
	end if
	
	sf$ = lfc_str$(x)
	if len(sf$) = 1 then sf$ = "0" + sf$
	sf$ = outprefix$ + "o" + sf$ + ".bmp"
	oti = lfc_new_image(getterdat2.width, (getterdat2.height * getterdat2.end_animation_frame_index))
	
	for gf = 0 to (getterdat2.end_animation_frame_index - 1)
	  afl = getterdat2.animation_frames_base_loc + (gf * getterdat2.animation_frame_data_size)
		if extloc = 1 then afl = afl + (getterdat2.unknown1 * 65536)
		afml = afl + getterdat2.mask_offset_from_image
	  ti = lfg_extract_image_mask(getterdat2.width, getterdat2.height, vg1, afl, afml, bd)
		lfc_clone_image ti, oti, 0, (gf * getterdat2.height)
		lfc_close_image ti
	next
	
	lfc_save_image oti, sf$
	lfc_close_image oti
  
next

Print "Saving INI file to disk..."

lfc_save_ini outini, ininame$

Print "Done!"

END